unit I2C_Bas;       {basic routines for I2C communocation}

interface

  Procedure I2C_Init;
  Procedure I2C_Start;
  Procedure I2C_Stop;
  Procedure Send_Ack;
  Procedure No_Ack;
  Procedure I2C_Aus(inp:byte; var ack:boolean);
  Function  I2C_ein : byte;
  function  Hex2int(hc:string):Longint;
  procedure Delay(Num: longint);
  Procedure ausgeben( raus : byte);

var SCL , SDA , SDA_RX, LPT_Adr : word;


implementation

uses winprocs;

procedure Delay(Num: longint);
var
   tc :longint;
begin
     tc := GetTickCount;
     repeat
          { Application.ProcessMessages;}
     until ((GetTickCount-tc) >= Num);
end;

function Hex2int(hc:string):Longint;
var subst: string;
    a,i: integer;
    lenhc:integer;
    hd: longint;
const H = '00112233445566778899aAbBcCdDeEfF';
    wertigkeit : array[1..4] of longint = (1,16,256,4096);
begin
  hd := 0;
  lenhc := length(hc);
  if lenhc > 4 then
  begin
    delete(hc,1,lenhc-4);
    lenhc := 4;
  end;
  for I := 1 TO lenhc do
  begin
    subst := copy(hc,lenhc-I+1,1);
    a := pos(subst,H);
    hd := hd + ((a-1) div 2) * (wertigkeit[I]);
  end;
  hex2int := hd;
end;

Procedure I2C_Init;
var u : byte;
begin
  port[LPT_Adr] := (port[LPT_Adr] AND 252) + SCL; {both hi == bus free}
end;

Procedure I2C_Start;
begin
  port[LPT_Adr] := (port[LPT_Adr] AND 252) + SCL; {both hi == bus free}
  port[LPT_Adr] := (port[LPT_Adr] AND 252) + SCL + SDA;
  port[LPT_Adr] := (port[LPT_Adr] AND 252) + SDA;
end;

Procedure I2C_Stop;
begin
  port[LPT_Adr] := (port[LPT_Adr] AND 252) + SDA;      {both low}
  port[LPT_Adr] := (port[LPT_Adr] AND 252) + SCL + SDA;
  port[LPT_Adr] := (port[LPT_Adr] AND 252) + SCL; {both hi == bus free}
end;

Procedure Send_Ack;
begin
  port[LPT_Adr] := (port[LPT_Adr] AND 252) + SDA;
  port[LPT_Adr] := (port[LPT_Adr] AND 252) + SCL + SDA;      {SDA low}
  port[LPT_Adr] := (port[LPT_Adr] AND 252) + SDA;
end;

Procedure No_Ack;
begin
  port[LPT_Adr] := (port[LPT_Adr] AND 252);
  port[LPT_Adr] := (port[LPT_Adr] AND 252) + SCL;
  port[LPT_Adr] := (port[LPT_Adr] AND 252);
end;

Procedure I2C_Aus(inp:byte; var ack:boolean);
var i,j,temp : byte;
begin
  ack := false;
  for i := 1 to 8 do
  begin
    temp := (inp AND 128) div 128;           {data bit to LSB}
    temp := temp * SDA;                      {data bit to SDA-pos}
    port[Lpt_Adr] := (port[LPT_Adr] AND 252) + (SDA - temp);{put data bit out to line}
    port[Lpt_Adr] := (port[LPT_Adr] AND 252) + (SDA - temp) + SCL;        {SCL hi}
    port[Lpt_Adr] := (port[LPT_Adr] AND 252) + (SDA - temp);{SCL lo}
    inp := inp * 2;                          {next bit position}
  end;
  port[Lpt_Adr] := (port[LPT_Adr] AND 252);         {SDA hi, SCL lo}
  port[Lpt_Adr] := (port[LPT_Adr] AND 252) + SCL;   {SCL hi}
  j := port[Lpt_Adr + 1] AND SDA_RX;                {read back Ack: shall be ZERO!!}
  if j = 0 then ack := true;                        {here nominal negative logic}
  port[Lpt_Adr] := (port[LPT_Adr] AND 252);         {SDA hi, SCL lo}
end;

FUNCTION I2C_ein : byte;
var i,u,res : byte;
begin
  res := 0;
  port[Lpt_Adr] := (port[LPT_Adr] AND 252);                 {SDA hi, SCL lo}
  for i := 1 to 8 do
  begin
    port[Lpt_Adr] := (port[LPT_Adr] AND 252) + SCL;         {SDA hi}
    res := res * 2;
    u := (port[Lpt_adr + 1] AND SDA_RX) div SDA_RX;
    res := res + u;
    port[Lpt_Adr] := (port[LPT_Adr] AND 252);               {SDA hi, SCL lo}
  end;
  i2C_ein := res;
end;

Procedure ausgeben( raus : byte);
var ack : boolean;
begin
  I2C_Start;
  I2C_Aus(64,ack);     {Adresse}
  I2C_Aus( raus,ack);  {ausgeben}
  I2C_Stop;
end;

end.
 